datacache <- new.env(hash=TRUE, parent=emptyenv())

sc.dbsubloc_dbconn <- function() dbconn(datacache)
sc.dbsubloc_dbfile <- function() dbfile(datacache)
sc.dbsubloc_dbschema <- function(file="", show.indices=FALSE) dbschema(datacache, 
    file=file, show.indices=show.indices)
sc.dbsubloc_dbInfo <- function() dbInfo(datacache)

.onLoad <- function(libname, pkgname)
{
    require("methods", quietly=TRUE)
    require("PAnnBuilder", quietly=TRUE)
    ## Connect to the SQLite DB
    dbfile <- system.file("extdata", "sc.dbsubloc.sqlite", package="sc.dbsubloc.db", 
        lib.loc=libname)
    assign("dbfile", dbfile, envir=datacache)
    dbconn <- dbFileConnect(dbfile)
    assign("dbconn", dbconn, envir=datacache)
    ## Create the AnnObj instances
    ann_objs <- createAnnObjs("DBSUBLOC", "sc.dbsubloc", datacache, dbconn)    
    mergeToNamespaceAndExport(ann_objs, "sc.dbsubloc.db" )
}

.onUnload <- function(libpath)
{
    dbFileDisconnect(sc.dbsubloc_dbconn())
}

